"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _prefix = require("./utils/prefix");

var ColumnGroup = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var header = props.header,
      className = props.className,
      children = props.children,
      classPrefix = props.classPrefix,
      headerHeight = props.headerHeight,
      verticalAlign = props.verticalAlign,
      width = props.width,
      rest = (0, _objectWithoutPropertiesLoose2["default"])(props, ["header", "className", "children", "classPrefix", "headerHeight", "verticalAlign", "width"]);
  var height = headerHeight / 2;
  var styles = {
    height: height,
    width: width
  };
  var contentStyles = (0, _extends2["default"])({}, styles, {
    verticalAlign: verticalAlign
  });
  var addPrefix = React.useCallback(function (name) {
    return (0, _prefix.prefix)(classPrefix)(name);
  }, []);
  return /*#__PURE__*/React.createElement("div", (0, _extends2["default"])({
    ref: ref,
    className: (0, _classnames["default"])(classPrefix, className)
  }, rest), /*#__PURE__*/React.createElement("div", {
    className: addPrefix('header'),
    style: styles
  }, /*#__PURE__*/React.createElement("div", {
    className: addPrefix('header-content'),
    style: contentStyles
  }, header)), React.Children.map(children, function (node) {
    var _node$props;

    var nodeStyles = (0, _extends2["default"])({
      height: height
    }, (_node$props = node.props) === null || _node$props === void 0 ? void 0 : _node$props.style, {
      top: styles.height
    });
    return /*#__PURE__*/React.cloneElement(node, {
      className: addPrefix('cell'),
      style: nodeStyles,
      headerHeight: height,
      verticalAlign: verticalAlign,
      children: /*#__PURE__*/React.createElement("span", {
        className: addPrefix('cell-content')
      }, node.props.children)
    });
  }));
});
ColumnGroup.displayName = 'ColumnGroup';
ColumnGroup.defaultProps = {
  headerHeight: 80,
  classPrefix: (0, _prefix.defaultClassPrefix)('table-column-group')
};
ColumnGroup.propTypes = {
  header: _propTypes["default"].node,
  classPrefix: _propTypes["default"].string,
  verticalAlign: _propTypes["default"].oneOf(['top', 'middle', 'bottom'])
};
var _default = ColumnGroup;
exports["default"] = _default;